<?php 
$controller = 'Station';
$action = '';
if(isset($_POST['action'])){
    $action = $_POST['action'];
    if (isset($_POST['id'])) {$id = $_POST['id'];}
}elseif(isset($_GET['action'])){
    $action = $_GET['action'];
    if (isset($_GET['id'])) {$id = $_GET['id'];}
}
include $_SERVER["DOCUMENT_ROOT"].'/app/include/bootstrap.php';

$_form = new EstacionForm();
$_estaciones = new EstacionEntity();
$_listaEstaciones = $_estaciones->getListaEstaciones();
switch($action){
    case 'insert':
        $_form->populate($_POST);
        if($_form->isValid()){
            $_estaciones->setOptions($_POST);
            $result = $_estaciones->save($_estaciones->getOptions());
            if($result){
                $flashmessenger->addMessage(array('success'=>'Estacion registrada exitosamente.'));
                header('Location: Station.php');
            }else{
                $flashmessenger->addMessage(array('danger'=>'Error. Intenta nuevamente o contacta a tu proveedor de sistemas.'));
            }
        }else{
            $vista = 'Estacion.php';
            include $root.'/View/Template.php';
        }
        break;
   
    case 'edit':
        if($_GET){$_estacionesData = $_estaciones->getById($id);}
        if($_POST){$_estacionesData = $_POST;}
        $_form->setActionController('edit');
        $_form->setId($id);
        $_form->populate($_estacionesData);
        
        if(isset($_POST['id'])){
            if($_form->isValid()){
                $_estaciones->setOptions($_estacionesData);
                $result = $_estaciones->update($id,$_estaciones->getOptions()); //no tengo id porque viene de post
                if($result){
                    $flashmessenger->addMessage(array('success'=>'Estacion actualizada exitosamente.'));
                    header("Location: Station.php?action=edit&id=$id");
                }else{
                    $flashmessenger->addMessage(array('danger'=>'Error. Intenta nuevamente o contacta a tu proveedor de sistemas.'));
                }       
            }else{
                $vista = 'Estacion.php';
                include $root . '/View/Template.php';
            }
        }else{
            $vista = 'Estacion.php';
            include $root . '/View/Template.php';
        }        
        break;
    
    case 'delete': 
        if(!$_estaciones->isUsedInRecord($id)){
            if($_estaciones->delete($id)){
                $flashmessenger->addMessage(array('success'=>'Estacion eliminadaS satisfactoriamente.'));
            }
        }else{
            $message = 'Esta Estacion no puede ser eliminada, esta siendo utilizado en almenos un registro.';
            $flashmessenger->addMessage(array('info'=>$message));
        }
        header('Location: Station.php');
        break;
    
    default:
        $vista = 'Estacion.php';
        include $root.'/View/Template.php';
}